﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_compare_string_compare
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnCompare_Click(object sender, EventArgs e)
        {
            // Get ready.
            Cursor = Cursors.WaitCursor;
            txtEqEq.Clear();
            txtStringCompare.Clear();
            txtIgnoreCase.Clear();
            txtEquals.Clear();
            txtEquals2.Clear();
            txtToLower.Clear();
            Application.DoEvents();

            int iterations = int.Parse(txtIterations.Text);
            string value0 = "AAAAAAAAAAAAAAAAAAAAAA";
            string value1 = "AAAAAAAAAAAAAAAAAAAAAA";
            string value2 = "AAAAAAAAAAAAAAAAAAAAAB";
            string value3 = "BAAAAAAAAAAAAAAAAAAAAA";
            DateTime start_time;
            TimeSpan elapsed;

            // ==.
            start_time = DateTime.Now;
            for (int i = 1; i <= iterations; i++)
            {
                if (value0 == value1) { }
                if (value0 == value2) { }
                if (value0 == value3) { }
            }
            elapsed = DateTime.Now - start_time;
            txtEqEq.Text = elapsed.TotalSeconds.ToString("0.000") + " sec";
            Application.DoEvents();

            // String.Compare (default is case-sensitive).
            start_time = DateTime.Now;
            for (int i = 1; i <= iterations; i++)
            {
                if (String.Compare(value0, value1, false) == 0) { }
                if (String.Compare(value0, value2, false) == 0) { }
                if (String.Compare(value0, value3, false) == 0) { }
            }
            elapsed = DateTime.Now - start_time;
            txtStringCompare.Text = elapsed.TotalSeconds.ToString("0.000") + " sec";
            Application.DoEvents();

            // String.Equals.
            start_time = DateTime.Now;
            for (int i = 1; i <= iterations; i++)
            {
                if (value0.Equals(value1)) { }
                if (value0.Equals(value2)) { }
                if (value0.Equals(value3)) { }
            }
            elapsed = DateTime.Now - start_time;
            txtEquals.Text = elapsed.TotalSeconds.ToString("0.000") + " sec";
            Application.DoEvents();

            // String.Compare, case-insensitive.
            start_time = DateTime.Now;
            for (int i = 1; i <= iterations; i++)
            {
                if (String.Compare(value0, value1, true) == 0) { }
                if (String.Compare(value0, value2, true) == 0) { }
                if (String.Compare(value0, value3, true) == 0) { }
            }
            elapsed = DateTime.Now - start_time;
            txtIgnoreCase.Text = elapsed.TotalSeconds.ToString("0.000") + " sec";
            Application.DoEvents();

            // String.Equals, case-insensitive.
            start_time = DateTime.Now;
            for (int i = 1; i <= iterations; i++)
            {
                if (value0.Equals(value1, StringComparison.CurrentCultureIgnoreCase)) { }
                if (value0.Equals(value2, StringComparison.CurrentCultureIgnoreCase)) { }
                if (value0.Equals(value3, StringComparison.CurrentCultureIgnoreCase)) { }
            }
            elapsed = DateTime.Now - start_time;
            txtEquals2.Text = elapsed.TotalSeconds.ToString("0.000") + " sec";
            Application.DoEvents();

            // ToLower.
            start_time = DateTime.Now;
            value1 = value1.ToLower();
            value2 = value2.ToLower();
            value3 = value3.ToLower();
            for (int i = 1; i <= iterations; i++)
            {
                if (value0.ToLower() == value1) { }
                if (value0.ToLower() == value2) { }
                if (value0.ToLower() == value3) { }
            }
            elapsed = DateTime.Now - start_time;
            txtToLower.Text = elapsed.TotalSeconds.ToString("0.000") + " sec";

            Cursor = Cursors.Default;
        }
    }
}